Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.bouncycastle.crypto.macs
Class KGMac

    java.lang.Object
      org.bouncycastle.crypto.macs.KGMac

All Implemented Interfaces:
  Mac

public class KGMac
extends java.lang.Object
implements Mac

The GMAC specialisation of Galois/Counter mode (GCM) detailed in NIST Special Publication 800-38D as adapted for the Kalyna version of GCM.

KGMac is an invocation of the KGCM mode where no data is encrypted (i.e. all input data to the Mac is processed as additional authenticated data with the underlying KGCM block cipher).

Constructor Summary
`KGMac(KGCMBlockCipher cipher)` Creates a KGMAC based on the operation of a block cipher in GCM mode.
`KGMac(KGCMBlockCipher cipher, int macSizeBits)` Creates a GMAC based on the operation of a 128 bit block cipher in GCM mode.

Method Summary
`int` | `doFinal(byte[] out, int outOff)` Compute the final stage of the MAC writing the output to the out parameter.
`java.lang.String` | `getAlgorithmName()` Return the name of the algorithm the MAC implements.
`int` | `getMacSize()` Return the block size for this MAC (in bytes).
`void` | `init(CipherParameters params)` Initialises the GMAC - requires a `ParametersWithIV` providing a `KeyParameter` and a nonce.
`void` | `reset()` Reset the MAC.
`void` | `update(byte in)` add a single byte to the mac for processing.
`void` | `update(byte[] in, int inOff, int len)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### KGMac

    public KGMac(KGCMBlockCipher cipher)

  Creates a KGMAC based on the operation of a block cipher in GCM mode.

  This will produce an authentication code the length of the block size of the cipher.

Parameters:
  `cipher` - the cipher to be used in GCM mode to generate the MAC.

### KGMac

    public KGMac(KGCMBlockCipher cipher,
                 int macSizeBits)

  Creates a GMAC based on the operation of a 128 bit block cipher in GCM mode.

Parameters:
  `macSizeBits` - the mac size to generate, in bits. Must be a multiple of 8 and >= 32 and <= 128. Sizes less than 96 are not recommended, but are supported for specialized applications.
  `cipher` - the cipher to be used in GCM mode to generate the MAC.

Method Detail

### init

    public void init(CipherParameters params)
              throws java.lang.IllegalArgumentException

  Initialises the GMAC - requires a `ParametersWithIV` providing a `KeyParameter` and a nonce.

  Specified by:
    `init` in interface `Mac`
  Parameters:
    `params` - the key and other data required by the MAC.
  Throws:
    `java.lang.IllegalArgumentException` - if the params argument is inappropriate.

### getAlgorithmName

    public java.lang.String getAlgorithmName()

  Description copied from interface: `Mac`
  Return the name of the algorithm the MAC implements.

  Specified by:
    `getAlgorithmName` in interface `Mac`
  Returns:
    the name of the algorithm the MAC implements.

### getMacSize

    public int getMacSize()

  Description copied from interface: `Mac`
  Return the block size for this MAC (in bytes).

  Specified by:
    `getMacSize` in interface `Mac`
  Returns:
    the block size for this MAC in bytes.

### update

    public void update(byte in)
                throws java.lang.IllegalStateException

  Description copied from interface: `Mac`
  add a single byte to the mac for processing.

  Specified by:
    `update` in interface `Mac`
  Parameters:
    `in` - the byte to be processed.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.

### update

    public void update(byte[] in,
                       int inOff,
                       int len)
                throws DataLengthException,
                       java.lang.IllegalStateException

  Specified by:
    `update` in interface `Mac`
  Parameters:
    `in` - the array containing the input.
    `inOff` - the index in the array the data begins at.
    `len` - the length of the input starting at inOff.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.
    `DataLengthException` - if there isn't enough data in in.

### doFinal

    public int doFinal(byte[] out,
                       int outOff)
                throws DataLengthException,
                       java.lang.IllegalStateException

  Description copied from interface: `Mac`
  Compute the final stage of the MAC writing the output to the out parameter.

  doFinal leaves the MAC in the same state it was after the last init.

  Specified by:
    `doFinal` in interface `Mac`
  Parameters:
    `out` - the array the MAC is to be output to.
    `outOff` - the offset into the out buffer the output is to start at.
  Throws:
    `java.lang.IllegalStateException` - if the MAC is not initialised.
    `DataLengthException` - if there isn't enough space in out.

### reset

    public void reset()

  Description copied from interface: `Mac`
  Reset the MAC. At the end of resetting the MAC should be in the in the same state it was after the last init (if there was one).

  Specified by:
    `reset` in interface `Mac`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Bouncy Castle Cryptography Library 1.84
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD